# Governance Policy

This document provides the governance policy for F3D (the "Project"). [Every person](./MAINTAINERS.md) responsible for its maintenance (the "Maintainers") agrees to this policy and to abide by all Project policies, including the [code of conduct](../../CODE-OF-CONDUCT.md) by adding their name to the [MAINTAINERS.md file](./MAINTAINERS.md).

## 1. Roles

This Project includes the following roles.

### 1.1. Maintainers

Maintainers are responsible for organizing activities around developing, maintaining, and updating the Project. Maintainers are also responsible for determining consensus. The Project may add or remove Maintainers by affirmative vote of 2/3 of all Maintainers.

### 1.2. Contributors

Contributors are those who have made contributions to the Project.

## 2. Decisions

### 2.1 Consensus-Based Decision Making

The Project makes decisions through the consensus of the Maintainers. While explicit agreement of all Maintainers is preferred, it is not required for consensus. Rather, the Maintainers will determine consensus based on their good faith consideration of several factors, including the dominant view of the Contributors and the nature of support and objections. The Maintainers will document evidence of consensus in accordance with these requirements using issues comments.

### 2.2. Appeal Process

Decisions may be appealed by opening an issue and that appeal will be considered by the Maintainers in good faith, who will respond in writing within a reasonable time.

## 3. How We Work

### 3.1. Openness

Participation is open to anyone who is directly and materially affected by the activity in question. There shall be no undue financial barriers to participation.

### 3.2. Balance

The development process should balance the interests of Contributors and other stakeholders. Contributors from diverse interest categories shall be sought with the objective of achieving balance.

### 3.3. Coordination and Harmonization

Good faith efforts shall be made to resolve potential conflicts or incompatibility between releases in the Project.

### 3.4. Consideration of Views and Objections

Prompt consideration shall be given to the written views and objections of all Contributors.

### 3.5. Written procedures

This governance document and other materials documenting the Project development process shall be available to any interested person.

## 4. No Confidentiality

Information disclosed in connection with any Project activity, including but not limited to meetings, contributions, and submissions, is not confidential, regardless of any markings or statements to the contrary.

## 5. Amendments

Amendments to this governance policy may be made by affirmative vote of 2/3 of all Maintainers.

---
Modified from of MVG-0.1-beta GOVERNANCE.md. Licensed under the [CC-BY 4.0 License](https://creativecommons.org/licenses/by-sa/4.0/).
